package
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	public class ReallyCoolGame extends Sprite
	{
		
		private var hero:Hero;
		private var villain:Villain;
		
		public function ReallyCoolGame()
		{
			super();
			_init();
		}
		
		private function _init():void
		{
			createHero();
			createVillain();
		}
		
		private function createHero():void
		{
			hero = new Hero();
			hero.addEventListener(MouseEvent.CLICK, handleClick, false, 0, true);
			addChild(hero);
		}
		
		private function createVillain():void
		{
			villain = new Villain();
			villain.addEventListener(MouseEvent.CLICK, handleClick, false, 0, true);
			addChild(villain);
		}
		
		private function destroyHero():void
		{
			if(hero != null)
			{
				hero.removeEventListener(MouseEvent.CLICK, handleClick);
				if(contains(hero))
				{
					removeChild(hero);
				}
				hero = null;
			}
		}
		
		private function destroyVillain():void
		{
			if(villain != null)
			{
				villain.removeEventListener(MouseEvent.CLICK, handleClick);
				if(contains(villain))
				{
					removeChild(villain);
				}
				villain = null;
			}
		}
		
		private function handleClick(event:MouseEvent):void
		{
			//Do something
		}
		
		public function destroy():void
		{
			destroyHero();
			destroyVillain();
		}
		
	}
}